"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var spawn = require('child_process').spawn;
var kill = require('tree-kill');
var ProcessPluginClass = (function () {
    function ProcessPluginClass(opts) {
        this.processList = {};
        this.opts = opts;
    }
    ;
    ProcessPluginClass.prototype.start = function () {
        var _this = this;
        this.opts.process.forEach(function (detail) {
            console.log("Starting " + detail.processKey + "...");
            var process = _this.createProcess(detail);
            _this.processList[detail.processKey] = process;
        });
    };
    ProcessPluginClass.prototype.stop = function () {
        for (var key in this.processList) {
            var detail = this.processList[key].detail;
            console.log("Killing " + detail.processKey + "...");
            kill(this.processList[key].process.pid);
            delete this.processList[key];
        }
    };
    ProcessPluginClass.prototype.postBundle = function (context) {
        this.stop();
        this.start();
    };
    ProcessPluginClass.prototype.createProcess = function (detail) {
        var _this = this;
        var process = {
            process: spawnProcess(detail.processName, detail.processArgs, detail.verbose),
            detail: detail
        };
        process.process.on('close', function (code, signal) {
            console.log("Finished " + detail.processKey + "...");
            delete _this.processList[detail.processKey];
        });
        return process;
    };
    return ProcessPluginClass;
}());
exports.ProcessPluginClass = ProcessPluginClass;
function ProcessPlugin(options) {
    return new ProcessPluginClass(options);
}
exports.ProcessPlugin = ProcessPlugin;
;
function spawnProcess(processName, processArgs, verbose) {
    if (verbose) {
        return spawn(processName, processArgs, { stdio: 'inherit' });
    }
    return spawn(processName, processArgs);
}
//# sourceMappingURL=plugin.js.map